

; V 1.01 (Aug. 2, 2005): fixed incident beam filter formatting problem

function read_comps, comp=comp,num_comps=num_comps,num_elements=num_elements
;
; reads the major element compositions file
;
   lun=1
   openr, lun, getenv('nrlxrf_dir')+'\comp_file.dat'
   num_comps=0
   x=' '
   while not EOF(lun) do begin
      readf, lun, x
;      temp=str_sep(x,' ')
      temp=strsplit(x,' ',/extract)
      comp.num_elements(num_comps)=(n_elements(temp)-2)/2
      n=comp.num_elements(num_comps)
      comp.name(num_comps)=temp(0)
      comp.density(num_comps)=float(temp(1))
      comp.element(num_comps,0:n-1)=temp(2*(1+indgen(n)))
      comp.conc(num_comps,0:n-1)=float(temp(2*(indgen(n))+3))
      num_comps=num_comps+1

   endwhile
   comp.num_comps=num_comps
   close, lun
   free_lun,lun
   return,lun
end

pro write_nrl, widgets, sample
;
; Generates command file for snrlxrf and spawns it's execution
;
; incident beam file
;
   openw, lun, 'xrdats.dat',/get_lun
   printf, lun, '12345 MONO'
   printf, lun, '12345 1'
   printf, lun, '12345 '+ strtrim(string(12.398/sample.energy),2) + ' 1.000000e+09'
   printf, lun, '12345 END'
   close,lun
   free_lun,lun
;
    openw, lun, sample.outfile,/get_lun
;
; header, parrot and long
;
   dummy0=''
   dummy1=''
   dummy2=''
   if sample.mode eq 0 then dummy0='Predict' else dummy0='Analyze'
   printf, lun, format="(6x,'#', a,/,/)", dummy0
   printf, lun, format="(/)"
   printf, lun, format="(6x,'PARROT')"
   printf, lun, format="(/)"
   printf, lun, format="(6x,'LONG')"
;
; filtering conditions
;
   if (sample.filters(0) eq 'None') then begin
      printf, lun, format="(/)"
;      printf, lun, format="(6x,'COND 45 45 MONO')"
;      printf, lun, format="(6x,'COND 70 20 MONO')"

    t1='(6x, '
    t2='COND '+strtrim(string(sample.angle_in),2)+ ' ' + strtrim(string(sample.angle_out),2) + ' MONO'
    t3=')'
    t=t1+'"'+t2+'"'+t3
    print, t
    printf, lun, format=t

   endif else begin
      dummy1=strupcase(strtrim(sample.filters(0),2))
      dummy3=sample.f_density(0)*sample.f_thick(0)*1e-4
 ;     print, dummy1, dummy3
      printf, lun, format="(/)"
;
;  use 45 45 for Sector 13 (CARS) and 70 20 for Sector 2 (SRI)
;
  ;  t1="'(6x, "
  ;  t2='COND '+strtrim(string(sample.angle_in),2)+ ' ' + strtrim(string(sample.angle_out),2) + ' MONO'
  ;  t3=")'"
    t1='(6x,'
    t2='COND '+strtrim(string(sample.angle_in),2)+ ' ' + strtrim(string(sample.angle_out),2) + ' MONO'
    t3=' '+dummy1 +' '+ strtrim(string(dummy3),2)
    t4=')'

     t=t1+'"'+t2+t3+'"'+t4
;    print,t
    ;print, dummy1,dummy3
;    wait,5
    printf, lun, format=t
   endelse
   dummy0=strupcase(strtrim(sample.filters(1),2))
   dummy1=strupcase(strtrim(sample.filters(2),2))
   dummy2=strupcase(strtrim(sample.filters(3),2))
   t=where(sample.filters[1:3] ne 'None',nfilters)
   dummy3=sample.f_density(1)*sample.f_thick(1)*1e-4
   dummy4=sample.f_density(2)*sample.f_thick(2)*1e-4
   dummy5=sample.f_density(3)*sample.f_thick(3)*1e-4
   printf, lun, format="(/)"
   if (nfilters eq 3) then printf, lun, format="(6x,'FILTERS ',(a8,1x,f12.5,1x,a8,1x,f12.5,1x,a8,1x,f12.5,1x))", dummy0,dummy3,dummy1,dummy4,dummy2,dummy5
   if (nfilters eq 2) then printf, lun, format="(6x,'FILTERS ',(a8,1x,f12.5,1x,a8,1x,f12.5,1x))", dummy0,dummy3,dummy1,dummy4
   if (nfilters eq 1) then printf, lun, format="(6x,'FILTERS ',(a8,1x,f12.5,1x))", dummy0,dummy3
   printf, lun, format="(/)"
;
; lines
;
   printf, lun, format="(6x,'LINES ')"
   for i=0,sample.num_sel_peaks-1 do begin
      dummy0=strupcase(strtrim(sample.peak_labels(sample.selected_fit,sample.selected_peaks(i)),2))
   ;
   ; NRLXRF uses A for argon
   ;
      if strmid(dummy0,0,2) eq 'AR' then strput,dummy0,'A ',0
      printf, lun, format="(6x,i2,1x,a)", i+1, dummy0
   endfor
   printf, lun, format="(/)"
;
; composition
;
   dummy8=strtrim(string(sample.density),2)
   dummy9=strtrim(string(sample.density*(1e-4*sample.thick)),2)
   printf, lun, format="(6x,'#  Thickness = ', a,' micrometers')", sample.thick
   printf, lun, format="(6x,'#  Density = ', a,' g/cm^3',/)", dummy8
;
; do this stuff for homogeneous samples
;
if (sample.kind_choice eq 0)then begin
   kind='COMP SAMPLE '+strupcase(strtrim(sample.kinds(sample.kind_choice),2))+' '
   printf, lun, format="(6x,a,1x,a)", kind, dummy9
   for i=0,sample.num_elements-1 do begin
      dummy0=strupcase(strtrim(sample.elem_label(i),2))
      if strmid(dummy0,0,2) eq 'AR' then strput,dummy0,'A ',0
      dummy3=strtrim(string(sample.conc(i)),2)
      printf, lun, format="(6x,a,1x,a)", dummy0, dummy3
   endfor
   printf, lun, format="(/)"
endif else begin
;
; do this stuff for separate samples
;
  kind='DEFINE TEMP '+strupcase(strtrim(sample.density,2))+' '
  printf, lun, format="(6x,a,1x,a,' WT')", kind, dummy8
  for i=0,sample.num_elements-1 do begin
      dummy0=strupcase(strtrim(sample.elem_label(i),2))
      dummy3=strtrim(string(sample.conc(i)),2)
      printf, lun, format="(6x,a,1x,a)", dummy0, dummy3
  endfor
  printf, lun, format="(/)"
  kind='COMP SAMPLE SEPARATE'
  printf, lun, format="(6x,a)", kind
  dummy3=strtrim(string(sample.density*sample.thick*1e-6),2)$
            +' '+strtrim(string(sample.thick),2)
  printf, lun, format="(6x,'TEMP',1x,a)", dummy3
  printf, lun, format="(/)"
endelse

; if predict: quit after predict statement
;
   if (sample.mode eq 0) then begin
      printf, lun, format="(/)"
      printf, lun, format="(6x, 'PREDICT SAMPLE ',/)"
      goto, ending
   endif
;
   printf, lun, format="(/)"
   printf, lun, format="(6x,'MAKESTANDARD SAMPLE',/)"
   printf, lun, format="(/)"
;
; repeat the composition for the unknown
;
   kind='COMP UNK '+strupcase(strtrim(sample.kinds(sample.kind_choice),2))+' '
   if (sample.kind_choice eq 1) then printf, lun, format="(6x,a)", kind $
      else printf, lun, format="(6x,a,1x,a)", kind, dummy9
   for i=0,sample.num_elements-1 do begin
      dummy0=strupcase(strtrim(sample.elem_label(i),2))
      if strmid(dummy0,0,2) eq 'AR' then strput,dummy0,'A ',0
      dummy3=strtrim(string(sample.conc(i)),2)
      if (sample.kind_choice eq 1)then $
         dummy3=strtrim(string(sample.conc(i)*sample.density*sample.thick/1.e6),2)+' '+strtrim(string(sample.thick),2)
      if sample.fixed(i) eq 'Unknown' then dummy3='?'
      printf, lun, format="(6x,a,1x,a)", dummy0, dummy3
   endfor

   printf, lun, format="(/)"
;
; peak intensities
;
   printf, lun, format="(6x, 'INTENSITIES UNK')"
   for i=0,sample.num_sel_peaks-1 do begin
      dummy0=sample.peak_areas(sample.selected_fit,sample.selected_peaks(i))
      printf, lun, format="(6x,i2,1x,e10.3)", i+1, dummy0
   endfor
   printf, lun, format="(/)"
   printf, lun, format="(6x, 'STANDARDIZE ', a7,/)", strupcase(strtrim(sample.ref_peak,2))
   printf, lun, format="(/)"
   printf, lun, format="(6x, 'ANALYZE UNK',/)"
 ending:
   printf, lun, format="(/)"
   printf, lun, format="(6x, 'INPUT 1')"

   close, lun
   free_lun,lun
;
; execute SNRLXRF
;

   sample.resultfile=sample.file_prefix+strtrim(string(sample.exec_num),2)+'.'+sample.file_suffix
   answer='Yes'
   test=findfile(sample.out_dir + sample.resultfile)
   if test(0) ne '' then begin
      string = 'The file '+sample.resultfile+' already exists in this folder - Do you want to overwrite it?'
      answer=dialog_message(string,/question, /default_no)
   endif
   if (answer eq 'No') then begin
      r=dialog_message('Please change the Output Filename and try again!',/info)
      goto, endpoint
   endif
   ;cd, current=working_dir
   command= getenv('nrlxrf_dir')+'\run_nrl '+ '"'+sample.out_dir +sample.resultfile+'"'
   print, command
   spawn, command
;
; display results
;
   xdisplayfile, sample.out_dir + sample.resultfile, font='truetype*15', title='NRLXRF Output'
   sample.exec_num=sample.exec_num+1
   sample.resultfile=sample.file_prefix+strtrim(string(sample.exec_num),2)+'.'+sample.file_suffix
   widget_control, widgets.outfile, set_value=sample.resultfile
   widget_control,widgets.base,/show
endpoint:
end

pro pred_peaks, sample,widgets
;
; This routine generates a list of predictable fluorescence peaks from the element list
;
   linetype=['KA','KB','LA1','LB1','LB2']
   text = ''
   for i=0,sample.num_elements-1 do begin
      for j=0,4 do begin
         sample.selected_fit=29
         sample.peak_labels(29,5*i+j)=sample.elem_label(i)+' '+linetype(j)
            sample.peak_areas(29,5*i+j)=0
            str = (sample.peak_labels(29,5*i+j))+ '   '
          ;  + ', ' + string(sample.peak_areas(29,5*i+j), format='(i7)')
         if (i eq 0 and j eq 0) then text = str else text = [text, str]
      endfor
    endfor
    widget_control, widgets.peak_list, set_value=text
end

pro write_comp, sample
;
; add a new composition to the comps file
;
   lun=5
   openw, lun, getenv('nrlxrf_dir')+'\comp_file.dat',/append
   text=strupcase(strtrim((sample.name),2))+ ' '+strtrim(string(sample.density),2)+' '
   for i=0,sample.num_elements-1 do begin
      text=text+strtrim(sample.elem_label(i),2)+' '
      text=text+strtrim(string(sample.conc(i)),2)+' '
   endfor
;  print, text
   printf,lun,format="(a)",text
   close, lun
   free_lun,lun
   end

pro read_fits, file, widgets, sample,comp
;
; reads a file containing fits generated by the EPICS MCA program
;
   if file eq '' then return
   openr, lun, file,/get_lun
   t1=' '
   temp1=' '
; loop on fits
   fit=-1
while not EOF(lun) do begin
; loop on peaks
   peak=0
   readf,lun,t1
   while (strmid(t1,4,3) ne 'Fit') do readf, lun, t1
   fit=fit+1
   help, sample.fit_names
   sample.fit_names(fit)=strtrim(t1,2)
   while (strmid(t1,9,4) ne 'Peak')and not EOF(lun) do readf, lun, t1
   readf,lun,t1
   readf,lun,t1
   while (strmid(t1,0,1) ne '' and not EOF(lun)) do begin
;     readf,lun,t1
      sample.peak_labels(fit,peak)=strtrim(strmid(t1,6,10),2)
      sample.peak_areas(fit,peak)=float(strmid(t1,37,11))
      peak=peak+1
      sample.npeaks(fit)=peak
      readf,lun,t1
   endwhile

; end of peaks loop

endwhile
   sample.peak_labels(fit,peak)=strtrim(strmid(t1,6,10),2)
   sample.peak_areas(fit,peak)=float(strmid(t1,37,11))
   sample.npeaks(fit)=peak+1
; end of fits loop
   sample.num_fits=fit+1
close, lun
free_lun,lun
end

pro read_VMS_fits, file, widgets, sample,comp
;
; reads a file containing fits generated by the VMS fit_spect.pro routine
;
   if file eq '' then return
   openr, lun, file,/get_lun
   t1=' '
   temp1=' '
; loop on fits
   fit=-1
while not EOF(lun) do begin

; loop on peak names
   peak=0
   readf,lun,t1
   fit=fit+1

   readf,lun,t1
   while (strtrim(t1,2) ne '##' and not EOF(lun)) do begin
      sample.peak_labels(fit,peak)=strtrim(strmid(t1,0,strlen(t1)-2),2)
      peak=peak+1
      sample.npeaks(fit)=peak
      readf,lun,t1
   endwhile
; end of peak names loop

; read peak areas
   readf,lun,t1
   sample.fit_names(fit)=strtrim(t1,2)
   readf,lun,t1
   for peak=0,sample.npeaks(fit)-1 do begin
      sample.peak_areas(fit,peak)=float(strtrim(strmid(t1,0,strlen(t1)-2),2))
      readf,lun,t1
   endfor
endwhile
; end of fits loop
   sample.num_fits=fit+1
close, lun
free_lun,lun
end

pro update_element_list, widgets, sample, comp

    text = ''
    for i=0, sample.num_elements-1 do begin
      if strlen(sample.elem_label(i)) eq 1 then sample.elem_label(i)=sample.elem_label(i)+ ' '
        str = (sample.elem_label(i)) + ', ' + $
              string(sample.conc(i), format='(f10.4)') + ', ' + $
              sample.fixed(i)
        if (i eq 0) then text = str else text = [text, str]
    endfor
    widget_control, widgets.element_list, set_value=text
    ;index = current > 0 < (n_elements(peaks)-1)
    ;widget_control, widgets.element_list, set_list_select=index
   index=0
    if (sample.num_elements gt 0) then $
      sample.comp_total=total(sample.conc(0:sample.num_elements-1)) $
    else sample.comp_total=0
   widget_control, widgets.comp_total, set_value=sample.comp_total
   update_selected_element, widgets, sample
end

pro update_selected_element, widgets, sample, comp
   if (sample.num_elements gt 0) then begin
;  print, sample.num_elements
      widget_control, widgets.el_choice_name, set_value=sample.elem_label(sample.el_choice)
      widget_control, widgets.el_choice_conc, set_value=sample.conc(sample.el_choice)
      temp=0 & if sample.fixed(sample.el_choice) ne 'Fixed' then temp=1
      widget_control, widgets.el_choice_fixed, set_droplist_select=temp
      widget_control, widgets.element_list, set_list_select=sample.el_choice
   endif else begin
      widget_control, widgets.el_choice_name, set_value=' '
      widget_control, widgets.el_choice_conc, set_value=0.
   endelse
end


pro snrlxrf_event, event
;
; main event manager
;
widget_control, event.top, get_uvalue=uvalue
widgets = uvalue.widgets
comp=uvalue.comp
sample=uvalue.sample
;print, event.id

case event.id of

    widgets.mode: begin
      widget_control, event.id, set_uvalue=event.index
      sample.mode=event.index
    if sample.mode eq 0 then pred_peaks,sample,widgets
    endcase
   widgets.energy: begin
      widget_control, event.id, set_uvalue=event.value
      sample.energy=event.value
   endcase
   widgets.angle_in: begin
      widget_control, event.id, set_uvalue=event.value
      sample.angle_in=event.value
   endcase
   widgets.angle_out: begin
      widget_control, event.id, set_uvalue=event.value
      sample.angle_out=event.value
   endcase
   widgets.tab: begin
  	;placeholder
   endcase

   widgets.filters(0): begin
      widget_control, event.id, set_uvalue=event.index
      sample.filters(0)=sample.filter_choices(event.index)
      widget_control, widgets.f_density(0), $
         set_uvalue=sample.filter_densities(event.index),$
         set_value=sample.filter_densities(event.index)
      sample.f_density(0)=sample.filter_densities(event.index)
      if (event.index eq 0) then widget_control, widgets.f_thick(0), $
            set_value=0, set_uvalue=0 & sample.f_thick(0)=0
      widget_control, widgets.filter0, set_value=sample.filter_choices(event.index)
   endcase
   widgets.filters(1): begin
      widget_control, event.id, set_uvalue=event.index
      sample.filters(1)=sample.filter_choices(event.index)
      widget_control, widgets.f_density(1), $
         set_uvalue=sample.filter_densities(event.index),$
         set_value=sample.filter_densities(event.index)
      sample.f_density(1)=sample.filter_densities(event.index)
      if (event.index eq 0) then widget_control, widgets.f_thick(1), $
            set_value=0, set_uvalue=0 & sample.f_thick(1)=0
      widget_control, widgets.filter1, set_value=sample.filter_choices(event.index)
   endcase
   widgets.filters(2): begin
      widget_control, event.id, set_uvalue=event.index
      sample.filters(2)=sample.filter_choices(event.index)
      widget_control, widgets.f_density(2), $
         set_uvalue=sample.filter_densities(event.index),$
         set_value=sample.filter_densities(event.index)
      sample.f_density(2)=sample.filter_densities(event.index)
      if (event.index eq 0) then widget_control, widgets.f_thick(2), $
            set_value=0, set_uvalue=0  & sample.f_thick(2)=0
      widget_control, widgets.filter2, set_value=sample.filter_choices(event.index)
   endcase
   widgets.filters(3): begin
      widget_control, event.id, set_uvalue=event.index
      sample.filters(3)=sample.filter_choices(event.index)
      widget_control, widgets.f_density(3), $
         set_uvalue=sample.filter_densities(event.index),$
         set_value=sample.filter_densities(event.index)
      sample.f_density(3)=sample.filter_densities(event.index)
      if (event.index eq 0) then widget_control, widgets.f_thick(3), $
            set_value=0, set_uvalue=0 & sample.f_thick(3)=0
      widget_control, widgets.filter3, set_value=sample.filter_choices(event.index)
   endcase
   widgets.filter0: begin
      sample.filters(0)=event.value
      widget_control, widgets.filters(0), set_uvalue=n_elements(sample.filter_choices)-1,$
         set_droplist_select=n_elements(sample.filter_choices)-1
   endcase
   widgets.filter1: begin
      sample.filters(1)=event.value
      widget_control, widgets.filters(1), set_uvalue=n_elements(sample.filter_choices)-1,$
         set_droplist_select=n_elements(sample.filter_choices)-1
   endcase
   widgets.filter2: begin
      sample.filters(2)=event.value
      widget_control, widgets.filters(2), set_uvalue=n_elements(sample.filter_choices)-1,$
         set_droplist_select=n_elements(sample.filter_choices)-1
   endcase
   widgets.filter3: begin
      sample.filters(3)=event.value
      widget_control, widgets.filters(3), set_uvalue=n_elements(sample.filter_choices)-1,$
         set_droplist_select=n_elements(sample.filter_choices)-1
   endcase
   widgets.f_density(0): begin
      widget_control, event.id, set_uvalue=event.value
      sample.f_density(0)=event.value
   endcase
   widgets.f_density(1): begin
      widget_control, event.id, set_uvalue=event.value
      sample.f_density(1)=event.value
   endcase
   widgets.f_density(2): begin
      widget_control, event.id, set_uvalue=event.value
      sample.f_density(2)=event.value
   endcase
   widgets.f_density(3): begin
      widget_control, event.id, set_uvalue=event.value
      sample.f_density(3)=event.value
   endcase

   widgets.f_thick(0): begin
      widget_control, event.id,set_uvalue=event.value
      sample.f_thick(0)=event.value
   endcase
   widgets.f_thick(1): begin
      widget_control, event.id,set_uvalue=event.value
      sample.f_thick(1)=event.value
   endcase
   widgets.f_thick(2): begin
      widget_control, event.id,set_uvalue=event.value
      sample.f_thick(2)=event.value
   endcase
   widgets.f_thick(3): begin
      widget_control, event.id,set_uvalue=event.value
      sample.f_thick(3)=event.value
   endcase

   widgets.s_density: begin
      widget_control, event.id,set_uvalue=event.value
      sample.density=event.value
   endcase
   widgets.s_thick: begin
      widget_control, event.id,set_uvalue=event.value
      sample.thick=event.value
   endcase

   widgets.s_kind: begin
      widget_control, event.id, set_uvalue=event.index
      sample.kind_choice=event.index
   endcase

   widgets.major_el_names: begin
      sample.name=comp.name(event.index)
      sample.elem_label=comp.element(event.index,*)
      sample.conc=comp.conc(event.index,*)
      sample.num_elements=comp.num_elements(event.index)
      ;
      print, 'Sample.num_elements ', sample.num_elements
      ;
      sample.fixed(0:sample.num_elements-1)='Fixed'
      sample.density=comp.density(event.index)
      sample.el_choice=0
      widget_control, event.id, set_uvalue=event.index
      widget_control, widgets.s_density, set_uvalue=comp.density(event.index),$
         set_value=comp.density(event.index)
      sample.el_choice=0
      update_element_list, widgets,sample
      sample.comp_total=total(sample.conc)
      widget_control, widgets.comp_total, set_value=sample.comp_total
      widget_control, widgets.comp_name, set_value=sample.name
      sample.name_index=event.index
   endcase
   widgets.element_list: begin
      sample.el_choice=event.index
      widget_control, event.id, set_uvalue=event.index
      update_selected_element, widgets, sample
   endcase
   widgets.el_choice_name: begin
      sample.elem_label(sample.el_choice)=event.value
      update_element_list, widgets,sample
   endcase
   widgets.el_choice_conc: begin
      sample.conc(sample.el_choice)=event.value
      update_element_list, widgets,sample
      sample.comp_total=total(sample.conc)
      widget_control, widgets.comp_total, set_value=sample.comp_total
   endcase
   widgets.el_choice_fixed: begin
      sample.fixed(sample.el_choice)='Fixed'
      if event.index ne 0 then sample.fixed(sample.el_choice)='Unknown'
      update_element_list, widgets, sample
   endcase
   widgets.add_el: begin
      sample.num_elements=sample.num_elements+1
      sample.elem_label(sample.num_elements-1)=' '
      sample.conc(sample.num_elements-1)=0.
      update_element_list, widgets, sample
      widget_control, widgets.el_choice_name, set_value = ' '
      widget_control, widgets.el_choice_conc, set_value = 0.
      sample.el_choice=sample.num_elements-1
      widget_control, widgets.element_list, set_list_select=sample.el_choice
      sample.el_choice=sample.num_elements-1
      sample.fixed(sample.el_choice)='Fixed'
    endcase
    widgets.delete_el: begin
      widget_control, widgets.element_list, get_uvalue=temp
      if temp lt sample.num_elements-1 then begin
        sample.elem_label(temp:sample.num_elements-1)=sample.elem_label(temp+1:sample.num_elements)
        sample.conc(temp:sample.num_elements-1)=sample.conc(temp+1:sample.num_elements)
        sample.fixed(temp:sample.num_elements-1)=sample.fixed(temp+1:sample.num_elements)
        endif
        sample.num_elements=sample.num_elements-1
      update_element_list, widgets, sample
      sample.el_choice=sample.num_elements-1
      widget_control, widgets.element_list, set_list_select=sample.el_choice
      update_selected_element, widgets, sample
    endcase
    widgets.clear_els: begin
      sample.num_elements=0
      update_element_list, widgets, sample
      widget_control, widgets.el_choice_name, set_value = ' '
      widget_control, widgets.el_choice_conc, set_value = 0.
   endcase
   widgets.sort: begin
      sample.elem_label=sample.elem_label(reverse(sort(sample.conc)))
      sample.fixed=sample.fixed(reverse(sort(sample.conc)))
      sample.conc=sample.conc(reverse(sort(sample.conc)))
      update_element_list, widgets, sample
      sample.el_choice=sample.num_elements-1
      widget_control, widgets.element_list, set_list_select=sample.el_choice
      update_selected_element, widgets, sample
    endcase
    widgets.renorm: begin
      conc_total=total(sample.conc(0:sample.num_elements-1))
      sample.conc=100*sample.conc/conc_total
      update_element_list, widgets, sample
      update_selected_element, widgets, sample
    endcase
    widgets.save_comp: begin
      comp.num_comps=comp.num_comps+1
      comp.name(comp.num_comps-1)=sample.name
 ;
 ;9/25/02 addition
 ;
      comp.num_elements(comp.num_comps-1)=sample.num_elements
 ;
      comp.density(comp.num_comps-1)=sample.density
      comp.element(comp.num_comps-1,0:sample.num_elements-1)=$
         sample.elem_label(0:sample.num_elements-1)
      comp.conc(comp.num_comps-1,0:sample.num_elements-1)=$
         sample.conc(0:sample.num_elements-1)
      write_comp, sample
      widget_control, widgets.major_el_names, set_value=comp.name(0:comp.num_comps-1),set_droplist_select=comp.num_comps-1
      sample.name_index=comp.num_comps-1
   endcase
   widgets.comp_name: begin
      widget_control, event.id, set_uvalue=event.value
      sample.name=event.value
   ;  print, sample.name
   endcase
   widgets.file_type: begin
      widget_control, event.id, set_uvalue=event.index
      sample.file_type=event.index
   endcase
    widgets.read_file: begin
      file=dialog_pickfile(/read)
      if sample.file_type eq 0 then read_fits, file,widgets,sample else read_vms_fits, file, widgets, sample
      widget_control, widgets.fit_list, set_value=sample.fit_names(0:sample.num_fits-1)
      widget_control, widgets.mode, set_uvalue=1, set_droplist_select=1
      sample.mode=1
    endcase
    widgets.fit_list: begin
      sample.selected_fit=event.index
      widget_control, event.id, set_uvalue=event.index
      text = ''
      for i=0, sample.npeaks(sample.selected_fit)-1 do begin
         if strlen(sample.peak_labels(sample.selected_fit,i)) eq 4 then $
            sample.peak_labels(sample.selected_fit,i)=sample.peak_labels(sample.selected_fit,i)+ ' '
         str = (sample.peak_labels(sample.selected_fit,i)) + ', ' + $
              string(sample.peak_areas(sample.selected_fit,i), format='(i10)')
         if (i eq 0) then text = str else text = [text, str]
      endfor
      widget_control, widgets.peak_list, set_value=text
      widget_control, widgets.mode, set_uvalue=1,set_droplist_select=1
      sample.mode=1
   endcase
   widgets.peak_list: begin
      t=widget_info(widgets.peak_list,/list_select)
      sample.num_sel_peaks=n_elements(t)
      sample.selected_peaks=t
;     print, sample.peak_labels(sample.selected_fit,sample.selected_peaks(0:sample.num_sel_peaks-1))

;
; see if we should add this element to element list
;
      test_pk= strtrim(strmid(sample.peak_labels(sample.selected_fit,sample.selected_peaks(0:sample.num_sel_peaks-1)),0,2),2)
      test_peak=test_pk(uniq(test_pk))
      test_elem= strtrim(strmid(sample.elem_label,0,2),2)
      for j=0,n_elements(test_peak)-1 do begin
         found=0
         for i=0,sample.num_elements-1 do begin
            if strmid(test_elem(i),1,1) eq ',' then test_elem(i)=strmid(test_elem(i),0,1)+' '
            if strupcase(test_peak(j)) eq strupcase(test_elem(i)) then found=1
 ;          print, strupcase(test_peak(j)), strupcase(test_elem(i)), found
         endfor
         if found eq 0 then begin
            sample.num_elements=sample.num_elements+1
            sample.elem_label(sample.num_elements-1)=test_peak(j)
            sample.conc(sample.num_elements-1)=0.1
            sample.fixed(sample.num_elements-1)='Unknown'
            update_element_list, widgets, sample
         endif
      endfor
 ;
 ; remove elements listed as unknowns which don't have a peak selected
 ;
      test_peak= strtrim(strmid(sample.peak_labels(sample.selected_fit,sample.selected_peaks(0:sample.num_sel_peaks-1)),0,2),2)
      test_elem= strtrim(strmid(sample.elem_label,0,2),2)
      for i=0,sample.num_elements-1 do begin
         found=0
 ;       print, sample.num_elements,sample.fixed, test_elem(i), i
         if sample.fixed(i) eq 'Unknown' then begin
         for j=0,sample.num_sel_peaks-1 do begin
            if strmid(test_elem(i),1,1) eq ' ' then test_elem(i)=strmid(test_elem(i),1,1)+' '
            if strupcase(test_peak(j)) eq strupcase(test_elem(i)) then found=1
         endfor
         if found eq 0 then begin
            if n_elements(remov) eq 0 then remov=i else remov=[remov,i]
         endif
         endif
      endfor
      if n_elements(remov) gt 0 then begin
         sample.elem_label(remov)='bad'
         sample.elem_label=sample.elem_label(where(sample.elem_label ne 'bad'))
         sample.conc(remov)=-1
         sample.conc=sample.conc(where(sample.conc gt 0))
         sample.fixed(remov)='bad'
         sample.fixed=sample.fixed(where(sample.fixed ne 'bad'))
         sample.num_elements=sample.num_elements-n_elements(remov)
         update_element_list, widgets, sample
         sample.el_choice=sample.num_elements-1
         widget_control, widgets.element_list, set_list_select=sample.el_choice
         update_selected_element, widgets, sample
      endif
   skip:
   endcase
   widgets.ref_peak: sample.ref_peak=event.value
   widgets.dir_button: begin
       full_path=dialog_pickfile(/write,file=sample.resultfile, get_path=temp)
       sample.out_dir=temp
       sample.resultfile=strmid(full_path, strlen(temp),strlen(full_path)-strlen(temp))
       widget_control, widgets.out_dir, set_value='Output Directory: ' + sample.out_dir
       widget_control, widgets.outfile, set_value=sample.resultfile
    endcase
    widgets.outfile: begin
      t=event.value
      period=strpos(t,'.')
;     print, period
      if (period gt 0) then begin
         sample.file_prefix=strmid(t,0,period)
         sample.file_suffix=strmid(t,period+1,strlen(t)-period-1)
      endif else sample.file_prefix=t
      print, sample.file_prefix
      sample.exec_num=0
   endcase
   widgets.run_nrl: write_nrl, widgets, sample

endcase
uvalue={widgets: widgets, comp: comp, sample: sample}
widget_control, event.top, set_uvalue=uvalue
save, filename='snrlxrf_save.sav',sample
end



pro snrlxrf
;
; generate the widgets and launch the event manager
;
cd, getenv('nrlxrf_dir'),current=old_dir
@nrl_init
cd, old_dir
t=read_comps(comp=comp,num_comps=num_comps,num_elements=num_elements)
   sample.name=comp.name(0)
   sample.elem_label=comp.element(0,*)
   sample.conc=comp.conc(0,*)
   sample.num_elements=comp.num_elements(0)
   sample.fixed(0:sample.num_elements-1)='Fixed'
   sample.density=comp.density(0)
   sample.thick=100.
   sample.el_choice=0
   sample.ref_peak='Fe Ka'
   sample.comp_total=total(sample.conc(0:sample.num_elements))
   choice=0
temp=findfile('snrlxrf_save.sav')
if (temp(0) eq 'snrlxrf_save.sav') then restore, 'snrlxrf_save.sav'
    base = widget_base(title='SNRLXRF',/row)
    widgets.base = base
    widgets.tab = widget_tab(widgets.base,/align_center)
    ;col1 = widget_base(base, /column, /frame)
    col1 = widget_base(widgets.tab, /column, title='Instrument Parameters')
    row1 = widget_base(col1, /row, /frame)
    colx=widget_base(row1,/col, /frame)
    t=widget_label(colx,value = 'SNRLXRF',font=get_font_name(/bold,/large))
    t=widget_label(colx,value = '',font=get_font_name(/bold,/large))
    t=widget_label(colx,value = '',font=get_font_name(/bold,/large))
    t=widget_label(colx,value = '',font=get_font_name(/bold,/large))
    t=widget_label(colx,value = '',font=get_font_name(/bold,/large))
    t=widget_label(colx,value = 'Version 1.01',font=get_font_name(/bold,/medium))

    col2=widget_base(base,/col)
    widgets.mode = widget_droplist( col2, title='           Mode',$
        value = ['Predict', 'Analyze'], uvalue=1,font=get_font_name(/bold,/small))
    widget_control, widgets.mode, set_droplist_select=sample.mode
    ;sample.mode=1
   ;energy=15.6
   ;rowa= widget_base(col1, /row,/frame)
    widgets.energy = cw_field(col2, title='Energy (keV)',xsize=7, $
           font=get_font_name(/bold, /small),value=sample.energy,/float,/return,uvalue=energy)
    cola=widget_base(row1,/col)
    widgets.angle_in = cw_field(col2, title='Angle-In    (deg)', xsize=6,$
           font=get_font_name(/bold, /small),value=sample.angle_in,/float,/return,uvalue=angle_in)
    widgets.angle_out = cw_field(col2, title='Angle-Out (deg)', xsize=6,$
           font=get_font_name(/bold, /small),value=sample.angle_out,/float,/return,uvalue=angle_out)

   row2 = widget_base(col1, /row)


   widgets.filters(0)=widget_droplist(row2,value=sample.filter_choices,$
      font=get_font_name(/bold, /small),title='Incid. Filter    ',uvalue=sample.filter_choices)
   widgets.filter0 = cw_field(row2, font=get_font_name(/small), xsize=8,title=' ', /return_events,value=sample.filters(0),uvalue=sample.filters(0))
   widgets.f_density(0)=cw_field(row2,title=' ',/float,/return,uvalue=sample.f_density(0),value=sample.f_density(0), xsize=8)
   t=widget_label(row2,value='g/cc')
   widgets.f_thick(0)=cw_field(row2,title=' ',/float,/return,uvalue=sample.f_thick(0),value=sample.f_thick(0), xsize=8)
   t=widget_label(row2,value='microns')

   row3=widget_base(col1,/row)
   widgets.filters(1)=widget_droplist(row3,value=sample.filter_choices, $
      font=get_font_name(/bold, /small),title='Det. Filter 1   ',uvalue=sample.filter_choices)
   widgets.filter1 = cw_field(row3, font=get_font_name(/small), xsize=8,title=' ', /return_events,value=sample.filters(1),uvalue=sample.filters(1))
    widgets.f_density(1)=cw_field(row3,title=' ',/float,/return,xsize=8,uvalue=sample.f_density(1),value=sample.f_density(1))
   t=widget_label(row3,value='g/cc')
   widgets.f_thick(1)=cw_field(row3,title=' ',/float,/return,xsize=8,uvalue=sample.f_thick(1),value=sample.f_thick(1))
   t=widget_label(row3,value='microns')

   row4=widget_base(col1,/row)
   widgets.filters(2)=widget_droplist(row4,value=sample.filter_choices, $
      font=get_font_name(/bold, /small),title='Det. Filter 2   ',uvalue=sample.filter_choices)
   widgets.filter2 = cw_field(row4, font=get_font_name(/small), xsize=8,title=' ', /return_events,value=sample.filters(2),uvalue=sample.filters(2))
   widgets.f_density(2)=cw_field(row4,title=' ',/float,/return,xsize=8,uvalue=sample.f_density(2),value=sample.f_density(2))
   t=widget_label(row4,value='g/cc')
   widgets.f_thick(2)=cw_field(row4,title=' ',/float,/return,xsize=8,uvalue=sample.f_thick(2),value=sample.f_thick(2))
   t=widget_label(row4,value='microns')

   row5=widget_base(col1,/row)
   widgets.filters(3)=widget_droplist(row5,value=sample.filter_choices, $
      font=get_font_name(/bold, /small),title='Det. Filter 3   ',uvalue=sample.filter_choices)
   widgets.filter3 = cw_field(row5, font=get_font_name(/small), xsize=8,title=' ', /return_events,value=sample.filters(3),uvalue=sample.filters(3))
   widgets.f_density(3)=cw_field(row5,title=' ',/float,/return,xsize=8,uvalue=sample.f_density(3),value=sample.f_density(3))
   t=widget_label(row5,value='g/cc')
   widgets.f_thick(3)=cw_field(row5,title=' ',/float,/return,xsize=8,uvalue=sample.f_thick(3),value=sample.f_thick(3))
   t=widget_label(row5,value='microns')

; Compositional Widgets start here
;

   col1 = widget_base(widgets.tab, /column, title='Compositional Parameters')
   col3=col1
   widgets.major_el_names=widget_droplist(col3,value=comp.name(0:num_comps-1),$
      title='SELECT COMP. or use ELEMENT features below ',$
      font=get_font_name(/bold, /small),uvalue=comp.name(choice))
      widget_control,widgets.major_el_names, set_droplist_select=sample.name_index
   row=widget_base(col3,/row)
   widgets.s_density=cw_field(row,title='Density (g/cc) ',/float,/return,xsize=7,$
      font=get_font_name(/bold, /small),uvalue=sample.density,value=sample.density)

   widgets.s_thick=cw_field(row,title='Thickness (microns) ',/float,/return,xsize=7,$
      font=get_font_name(/bold, /small),uvalue=sample.thick,value=sample.thick)
   widgets.s_kind=widget_droplist(row,value=sample.kinds,font=get_font_name(/bold,/small),$
      uvalue=sample.kinds(sample.kind_choice))

   row = widget_base(col3, /row,/frame)
   t=widget_label(row,font=get_font_name(/bold, /small),value= 'MODIFY >> ')
    widgets.el_choice_name = cw_field(row, font=get_font_name(/bold, /small),title='Element', xsize=4,/column, /return_events)
   widgets.el_choice_conc = cw_field(row, font=get_font_name(/bold, /small),title='Wt %',xsize=7, /column, /return_events,/float)
   col4=widget_base(row,/column)
   widgets.el_choice_fixed_label = widget_label(col4,value="Optimize?",font=get_font_name(/bold,/small))
   widgets.el_choice_fixed = widget_droplist(col4,value = ['Fixed', 'Unknown'], uvalue=0)

   col = widget_base(row, /column)
   row = widget_base(col1, /row)
    col = widget_base(row, /column)
   widgets.comp_name = cw_field(col,font=get_font_name(/bold, /small),title='NAME > ',xsize=7,value=sample.name,/return_events)
    widgets.add_el = widget_button(col, font=get_font_name(/bold, /small),xsize=1,units=1,value='ADD')
    widgets.delete_el = widget_button(col, font=get_font_name(/bold, /small),xsize=1,units=1,value='DELETE')
    widgets.clear_els = widget_button(col, font=get_font_name(/bold, /small),xsize=1,units=1,value='CLEAR ALL')
    widgets.sort = widget_button(col, font=get_font_name(/bold, /small),xsize=1,units=1,value='SORT')
   widgets.renorm = widget_button(col, font=get_font_name(/bold, /small),xsize=1,units=1,value='RENORMALIZE')
   widgets.save_comp = widget_button(col, font=get_font_name(/bold, /small),xsize=1,units=1,value='SAVE COMP')
   widgets.comp_total=cw_field(col,font=get_font_name(/bold, /small),title='TOTAL (%) ',xsize=7,value=string(sample.comp_total))
    text = ' '
    col6 = widget_base(row, /column)
   widgets.peak_list_label= widget_label(col6,value="Element List",$
      font=get_font_name(/bold,/small))
   widgets.element_list = widget_list(col6, font='courier10',ysize=15, value=text,uvalue=0)
   ;
; Peak area widgets start here
;
   row6=widget_base(col1,/row,/frame)
   co=widget_base(row6,/col)
   widgets.read_file=widget_button(co,$
      font=get_font_name(/bold, /small),value='READ A PEAK FITS FILE')
   widgets.file_type = widget_droplist( co, title='Peak File Type',$
        value = ['EPICS', 'VMS'], uvalue=0,font=get_font_name(/bold,/small))
   widgets.fit_list = widget_list(row6, value=' ',uvalue=0,ysize=5,xsize=40,$
      font=get_font_name(/small))
   widget_control, widgets.fit_list, set_value=sample.fit_names(0:((sample.num_fits-1)>0))
;  row7=widget_base(col1,/row,/frame)
   col7 = widget_base(row, /column)
   widgets.peak_list_label= widget_label(col7,value="Peak List",font=get_font_name(/bold,/small))

   text = ''
      for i=0, sample.npeaks(sample.selected_fit)-1 do begin
         if strlen(sample.peak_labels(sample.selected_fit,i)) eq 4 then $
            sample.peak_labels(sample.selected_fit,i)=sample.peak_labels(sample.selected_fit,i)+ ' '
         str = (sample.peak_labels(sample.selected_fit,i)) + ', ' + $
              string(sample.peak_areas(sample.selected_fit,i), format='(i10)')
         if (i eq 0) then text = str else text = [text, str]
      endfor
;     widget_control, widgets.peak_list, set_value=text

   widgets.peak_list = widget_list(col7,value=text,$
      /multiple,ysize=15,uvalue=0,font='courier10')
   if sample.mode eq 0 then pred_peaks,sample,widgets

;  widgets.peak_list = widget_list(col7,value=sample.peak_labels(0,*),$
;     /multiple,ysize=15,uvalue=0,font='courier')
   widgets.ref_peak=cw_field(col, title='Ref. Peak ', value=sample.ref_peak,$
      font=get_font_name(/bold, /small),xsize=10, /return_events)
;
   row7=widget_base(col1,/row)
   cd, current=temp
   sample.out_dir=temp + '\'
   widgets.out_dir=widget_label(row7, font=get_font_name(/bold, /small),/dynamic, /align_left,value='Output Directory: '+sample.out_dir)
   sample.resultfile=sample.file_prefix+strtrim(string(sample.exec_num),2)+'.'+sample.file_suffix
   row8=widget_base(col1,/row)
   widgets.outfile = cw_field(row8, title='Output File: ',font=get_font_name(/bold, /small),/return_events,value=sample.resultfile)


   widgets.dir_button=widget_button(row8,$
      font=get_font_name(/bold, /small),value='Change Directory')
   widgets.run_nrl=widget_button(row8,font=get_font_name(/bold, /small),value='Run SNRLXRF')
   uvalue={widgets: widgets, comp: comp, sample: sample}
    widget_control, base, /realize,set_uvalue=uvalue
    widget_control,default_font=get_font_name(/small)
   update_element_list, widgets,sample

xmanager, "snrlxrf", base,/no_block
end


